Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 777681 (CVE-2021-3449, CVE-2021-3450) - <dev-libs/openssl-1.1.1k: multiple vulnerabilities (CVE-2021-{3449,3450})
Summary: <dev-libs/openssl-1.1.1k: multiple vulnerabilities (CVE-2021-{3449,3450})
Status: RESOLVED FIXED
Alias: CVE-2021-3449, CVE-2021-3450
Product: Gentoo Security
Classification: Unclassified
Component: Vulnerabilities (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Deadline: 2021-03-28
Assignee: Gentoo Security
URL: https://www.openssl.org/news/secadv/2...
Whiteboard: A3 [glsa+ cve]
Keywords:
Depends on:
Blocks:
 
Reported: 2021-03-22 09:46 UTC by Sam James
Modified: 2021-04-03 19:23 UTC (History)
6 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Sam James archtester gentoo-dev Security 2021-03-22 09:46:53 UTC
From https://mta.openssl.org/pipermail/openssl-announce/2021-March/000196.html:

The OpenSSL project team would like to announce the forthcoming
release of OpenSSL version 1.1.1k.

This release will be made available on Thursday 25th March 2021
between 1300-1700 UTC.

OpenSSL 1.1.1k is a security-fix release. The highest severity issue
fixed in this release is HIGH:
https://www.openssl.org/policies/secpolicy.html#high

Yours

The OpenSSL Project Team
Comment 1 Sam James archtester gentoo-dev Security 2021-03-25 14:05:44 UTC
CA certificate check bypass with X509_V_FLAG_X509_STRICT (CVE-2021-3450)
========================================================================

Severity: High

The X509_V_FLAG_X509_STRICT flag enables additional security checks of the
certificates present in a certificate chain. It is not set by default.

Starting from OpenSSL version 1.1.1h a check to disallow certificates in
the chain that have explicitly encoded elliptic curve parameters was added
as an additional strict check.

An error in the implementation of this check meant that the result of a
previous check to confirm that certificates in the chain are valid CA
certificates was overwritten. This effectively bypasses the check
that non-CA certificates must not be able to issue other certificates.

If a "purpose" has been configured then there is a subsequent opportunity
for checks that the certificate is a valid CA.  All of the named "purpose"
values implemented in libcrypto perform this check.  Therefore, where
a purpose is set the certificate chain will still be rejected even when the
strict flag has been used. A purpose is set by default in libssl client and
server certificate verification routines, but it can be overridden or
removed by an application.

In order to be affected, an application must explicitly set the
X509_V_FLAG_X509_STRICT verification flag and either not set a purpose
for the certificate verification or, in the case of TLS client or server
applications, override the default purpose.

OpenSSL versions 1.1.1h and newer are affected by this issue. Users of these
versions should upgrade to OpenSSL 1.1.1k.

OpenSSL 1.0.2 is not impacted by this issue.

This issue was reported to OpenSSL on 18th March 2021 by Benjamin Kaduk
from Akamai and was discovered by Xiang Ding and others at Akamai. The fix was
developed by Tomáš Mráz.


NULL pointer deref in signature_algorithms processing (CVE-2021-3449)
=====================================================================

Severity: High

An OpenSSL TLS server may crash if sent a maliciously crafted renegotiation
ClientHello message from a client. If a TLSv1.2 renegotiation ClientHello omits
the signature_algorithms extension (where it was present in the initial
ClientHello), but includes a signature_algorithms_cert extension then a NULL
pointer dereference will result, leading to a crash and a denial of service
attack.

[...]
Comment 2 Larry the Git Cow gentoo-dev 2021-03-25 14:30:01 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=45e98bc5c10d396ab6ffbeec50ee78093683fdf9

commit 45e98bc5c10d396ab6ffbeec50ee78093683fdf9
Author:     Thomas Deutschmann <whissi@gentoo.org>
AuthorDate: 2021-03-25 14:29:45 +0000
Commit:     Thomas Deutschmann <whissi@gentoo.org>
CommitDate: 2021-03-25 14:29:57 +0000

    dev-libs/openssl: bump to v1.1.1k
    
    Bug: https://bugs.gentoo.org/777681
    Package-Manager: Portage-3.0.17, Repoman-3.0.2
    Signed-off-by: Thomas Deutschmann <whissi@gentoo.org>

 dev-libs/openssl/Manifest              |   1 +
 dev-libs/openssl/openssl-1.1.1k.ebuild | 326 +++++++++++++++++++++++++++++++++
 2 files changed, 327 insertions(+)
Comment 3 Thomas Deutschmann gentoo-dev Security 2021-03-25 14:31:32 UTC
Note: <1.1.x is not affected.
Comment 4 Sam James archtester gentoo-dev Security 2021-03-25 23:12:27 UTC
amd64 done
Comment 5 Sam James archtester gentoo-dev Security 2021-03-25 23:15:26 UTC
x86 done
Comment 6 Sam James archtester gentoo-dev Security 2021-03-25 23:17:40 UTC
ppc done
Comment 7 Sam James archtester gentoo-dev Security 2021-03-25 23:18:31 UTC
ppc64 done
Comment 8 Sam James archtester gentoo-dev Security 2021-03-25 23:39:09 UTC
sparc done
Comment 9 Sam James archtester gentoo-dev Security 2021-03-26 00:08:24 UTC
arm64 done
Comment 10 Fabian Groffen gentoo-dev 2021-03-26 07:55:05 UTC
prefix done
Comment 11 Agostino Sarubbo gentoo-dev 2021-03-26 11:50:47 UTC
s390 stable
Comment 12 Rolf Eike Beer archtester 2021-03-26 17:02:57 UTC
hppa stable
Comment 13 Sam James archtester gentoo-dev Security 2021-03-28 07:10:56 UTC
arm done

all arches done
Comment 14 John Helmert III gentoo-dev Security 2021-03-28 14:48:18 UTC
Please cleanup.
Comment 15 Larry the Git Cow gentoo-dev 2021-03-28 16:47:28 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=585d8fe6342e713eddbcdc7e560f51c3721532f8

commit 585d8fe6342e713eddbcdc7e560f51c3721532f8
Author:     Thomas Deutschmann <whissi@gentoo.org>
AuthorDate: 2021-03-28 16:47:06 +0000
Commit:     Thomas Deutschmann <whissi@gentoo.org>
CommitDate: 2021-03-28 16:47:06 +0000

    dev-libs/openssl: security cleanup
    
    Bug: https://bugs.gentoo.org/777681
    Package-Manager: Portage-3.0.17, Repoman-3.0.2
    Signed-off-by: Thomas Deutschmann <whissi@gentoo.org>

 dev-libs/openssl/Manifest              |   2 -
 dev-libs/openssl/openssl-1.1.1i.ebuild | 326 ---------------------------------
 dev-libs/openssl/openssl-1.1.1j.ebuild | 326 ---------------------------------
 3 files changed, 654 deletions(-)
Comment 16 Thomas Deutschmann gentoo-dev Security 2021-03-31 11:28:25 UTC
Added to an existing GLSA request.
Comment 17 GLSAMaker/CVETool Bot gentoo-dev 2021-04-03 19:23:15 UTC
This issue was resolved and addressed in
 GLSA 202103-03 at https://security.gentoo.org/glsa/202103-03
by GLSA coordinator Thomas Deutschmann (whissi).